// nstesdoc.cpp : implementation of the CNstestDoc class
//

#include "stdafx.h"
#include "nstest.h"

#include "nstesdoc.h"
#include "cntritem.h"
#include "srvritem.h"

#include "ddeobj.h"
#include "network.h"
#include "registry.h"

#include "dlgactiv.h"
#include "dlgcance.h"
#include "dlggetwi.h"
#include "dlgopenu.h"
#include "dlgparse.h"
#include "dlgregis.h"
#include "dlgurlec.h"
#include "dlgviewe.h"
#include "dlgwindo.h"
#include "dlgshowf.h"
#include "unregist.h"
#include "unurlech.h"
#include "unviewer.h"
#include "unwindow.h"
#include "dlgchang.h"
#include "dqueryur.h"
#include "odregpro.h"
#include "odregvie.h"
#include "odnetope.h"
#include "odnetrea.h"
#include "odnetres.h"
#include "odnetset.h"
#include "odnetnew.h"
#include "odnetall.h"
#include "odnetpas.h"
#include "odnetuse.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CNstestDoc

IMPLEMENT_DYNCREATE(CNstestDoc, COleServerDoc)

BEGIN_MESSAGE_MAP(CNstestDoc, COleServerDoc)
	//{{AFX_MSG_MAP(CNstestDoc)
	ON_COMMAND(ID_WWW_ACTIVATE, OnWwwActivate)
	ON_COMMAND(ID_WWW_CANCELPROGRESS, OnWwwCancelprogress)
	ON_COMMAND(ID_WWW_EXIT, OnWwwExit)
	ON_COMMAND(ID_WWW_GETWINDOWINFO, OnWwwGetwindowinfo)
	ON_COMMAND(ID_WWW_OPENURL, OnWwwOpenurl)
	ON_COMMAND(ID_WWW_PARSEANCHOR, OnWwwParseanchor)
	ON_COMMAND(ID_WWW_REGISTERPROTOCOL, OnWwwRegisterprotocol)
	ON_COMMAND(ID_WWW_REGISTERURLECHO, OnWwwRegisterurlecho)
	ON_COMMAND(ID_WWW_REGISTERVIEWER, OnWwwRegisterviewer)
	ON_COMMAND(ID_WWW_REGISTERWINDOWCHANGE, OnWwwRegisterwindowchange)
	ON_COMMAND(ID_WWW_SHOWFILE, OnWwwShowfile)
	ON_COMMAND(ID_WWW_UNREGISTERPROTOCOL, OnWwwUnregisterprotocol)
	ON_COMMAND(ID_WWW_UNREGISTERURLECHO, OnWwwUnregisterurlecho)
	ON_COMMAND(ID_WWW_UNREGISTERVIEWER, OnWwwUnregisterviewer)
	ON_COMMAND(ID_WWW_UNREGISTERWINDOWCHANGE, OnWwwUnregisterwindowchange)
	ON_COMMAND(ID_WWW_VERSION, OnWwwVersion)
	ON_COMMAND(ID_WWW_WINDOWCHANGE, OnWwwWindowchange)
	ON_COMMAND(ID_WWW_LISTWINDOWS, OnWwwListwindows)
	ON_COMMAND(ID_WWW_QUERYURLFILE, OnWwwQueryurlfile)
	ON_COMMAND(ID_OLE_NETWORK1_BYTESREADY, OnOleNetwork1Bytesready)
	ON_COMMAND(ID_OLE_NETWORK1_CLOSE, OnOleNetwork1Close)
	ON_COMMAND(ID_OLE_NETWORK1_GETCONTENTENCODING, OnOleNetwork1Getcontentencoding)
	ON_COMMAND(ID_OLE_NETWORK1_GETCONTENTLENGTH, OnOleNetwork1Getcontentlength)
	ON_COMMAND(ID_OLE_NETWORK1_GETCONTENTTYPE, OnOleNetwork1Getcontenttype)
	ON_COMMAND(ID_OLE_NETWORK1_GETERRORMESSAGE, OnOleNetwork1Geterrormessage)
	ON_COMMAND(ID_OLE_NETWORK1_GETEXPIRES, OnOleNetwork1Getexpires)
	ON_COMMAND(ID_OLE_NETWORK1_GETFLAGFANCYFTP, OnOleNetwork1Getflagfancyftp)
	ON_COMMAND(ID_OLE_NETWORK1_GETFLAGFANCYNEWS, OnOleNetwork1Getflagfancynews)
	ON_COMMAND(ID_OLE_NETWORK1_GETFLAGSHOWALLNEWS, OnOleNetwork1Getflagshowallnews)
	ON_COMMAND(ID_OLE_NETWORK1_GETLASTMODIFIED, OnOleNetwork1Getlastmodified)
	ON_COMMAND(ID_OLE_NETWORK1_GETPASSWORD, OnOleNetwork1Getpassword)
	ON_COMMAND(ID_OLE_NETWORK1_GETSERVERSTATUS, OnOleNetwork1Getserverstatus)
	ON_COMMAND(ID_OLE_NETWORK1_GETSTATUS, OnOleNetwork1Getstatus)
	ON_COMMAND(ID_OLE_NETWORK1_GETUSERNAME, OnOleNetwork1Getusername)
	ON_COMMAND(ID_OLE_NETWORK1_ISFINISHED, OnOleNetwork1Isfinished)
	ON_COMMAND(ID_OLE_NETWORK1_OPEN, OnOleNetwork1Open)
	ON_COMMAND(ID_OLE_NETWORK1_READ, OnOleNetwork1Read)
	ON_COMMAND(ID_OLE_NETWORK1_RESOLVE, OnOleNetwork1Resolve)
	ON_COMMAND(ID_OLE_NETWORK1_SETFLAGFANCYFTP, OnOleNetwork1Setflagfancyftp)
	ON_COMMAND(ID_OLE_NETWORK1_SETFLAGFANCYNEWS, OnOleNetwork1Setflagfancynews)
	ON_COMMAND(ID_OLE_NETWORK1_SETFLAGSHOWALLNEWS, OnOleNetwork1Setflagshowallnews)
	ON_COMMAND(ID_OLE_NETWORK1_SETPASSWORD, OnOleNetwork1Setpassword)
	ON_COMMAND(ID_OLE_NETWORK1_SETUSERNAME, OnOleNetwork1Setusername)
	ON_COMMAND(ID_OLE_REGISTRY1_REGISTERPROTOCOL, OnOleRegistry1Registerprotocol)
	ON_COMMAND(ID_OLE_REGISTRY1_REGISTERVIEWER, OnOleRegistry1Registerviewer)
	//}}AFX_MSG_MAP
	// Enable default OLE container implementation
	ON_UPDATE_COMMAND_UI(ID_EDIT_PASTE, COleServerDoc::OnUpdatePasteMenu)
	ON_UPDATE_COMMAND_UI(ID_EDIT_PASTE_LINK, COleServerDoc::OnUpdatePasteLinkMenu)
	ON_UPDATE_COMMAND_UI(ID_OLE_EDIT_LINKS, COleServerDoc::OnUpdateEditLinksMenu)
	ON_COMMAND(ID_OLE_EDIT_LINKS, COleServerDoc::OnEditLinks)
	ON_UPDATE_COMMAND_UI(ID_OLE_VERB_FIRST, COleServerDoc::OnUpdateObjectVerbMenu)
	ON_UPDATE_COMMAND_UI(ID_OLE_EDIT_CONVERT, COleServerDoc::OnUpdateObjectVerbMenu)
	ON_COMMAND(ID_OLE_EDIT_CONVERT, COleServerDoc::OnEditConvert)
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CNstestDoc, COleServerDoc)
	//{{AFX_DISPATCH_MAP(CNstestDoc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//      DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNstestDoc construction/destruction

CNstestDoc::CNstestDoc()
{
	// For most containers, using compound files is a good idea.
	EnableCompoundFile();

	EnableAutomation();

	// TODO: add one-time construction code here
	
	//	Initialize variables only.
	//	As a standard all variables must have a state of being set to NULL
	//		before they are actually allocated, in case we THROW and other
	//		code attempts to delete the object.
	//	We'll do all signifigant state initialization in OnNewDocument().
	m_pDDE = NULL;
	m_pOLENetwork1 = NULL;
	m_pOLERegistry1 = NULL;

	AfxOleLockApp();
}

CNstestDoc::~CNstestDoc()
{
	//	Get rid of objects.
	if(m_pDDE != NULL)	{
		delete m_pDDE;
		m_pDDE = NULL;
	}
	if(m_pOLENetwork1 != NULL)	{
		delete m_pOLENetwork1;
		m_pOLENetwork1 = NULL;
	}
	if(m_pOLERegistry1 != NULL)	{
		delete m_pOLERegistry1;
		m_pOLERegistry1 = NULL;
	}

	AfxOleUnlockApp();
}

BOOL CNstestDoc::OnNewDocument()
{
	if (!COleServerDoc::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)
	
	//	Free off any objects if they are still around.
	if(m_pDDE != NULL)	{
		delete m_pDDE;
		m_pDDE = NULL;
	}
	if(m_pOLENetwork1 != NULL)	{
		delete m_pOLENetwork1;
		m_pOLENetwork1 = NULL;
	}
	if(m_pOLERegistry1 != NULL)	{
		delete m_pOLERegistry1;
		m_pOLERegistry1 = NULL;
	}
	
	//	Create a new DDE object to handle DDE conversations for this document.
	//	new should THROW if unable to allocate.
	m_pDDE = new CDDEObject(this);
	
	//	Create a new OLE Network object to handle netowrk loads for this document.
	m_pOLENetwork1 = new CNetscapeNetwork1;
	m_pOLENetwork1->CreateDispatch("Netscape.Network.1");

	//	Create a new OLE Network object to handle registrations for this document.
	m_pOLERegistry1 = new CNetscapeRegistry1;
	m_pOLERegistry1->CreateDispatch("Netscape.Registry.1");

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CNstestDoc server implementation

COleServerItem* CNstestDoc::OnGetEmbeddedItem()
{
	// OnGetEmbeddedItem is called by the framework to get the COleServerItem
	//  that is associated with the document.  It is only called when necessary.

	CNstestSrvrItem* pItem = new CNstestSrvrItem(this);
	ASSERT_VALID(pItem);
	return pItem;
}

/////////////////////////////////////////////////////////////////////////////
// CNstestDoc serialization

void CNstestDoc::Display(const char *pString)	{
	//	Send this string to our views.
	if(pString != NULL)	{
		if(*pString != '\0')	{
			m_Display.AddTail(CString(pString));
			UpdateAllViews(NULL, strlen(pString));
		}
	}
}

void CNstestDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
	
	//	Will handle on own if load/save calls here.
	m_pDDE->Serialize(ar);
	
	// Calling the base class COleServerDoc enables serialization
	//  of the container document's COleClientItem objects.
	COleServerDoc::Serialize(ar);
}

BOOL CNstestDoc::OnOpenDocument(const char *pszPathName)	{
	BOOL bRetVal = COleServerDoc::OnOpenDocument(pszPathName);
	return(bRetVal);
}

/////////////////////////////////////////////////////////////////////////////
// CNstestDoc diagnostics

#ifdef _DEBUG
void CNstestDoc::AssertValid() const
{
	COleServerDoc::AssertValid();
}

void CNstestDoc::Dump(CDumpContext& dc) const
{
	COleServerDoc::Dump(dc);
	
	m_pDDE->Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CNstestDoc commands

void CNstestDoc::OnWwwActivate() 
{
	// TODO: Add your command handler code here
	CDLGActivate dlgActivate;
	dlgActivate.m_dwWindowID = -1;
	
	if(dlgActivate.DoModal() == IDOK)	{
		m_pDDE->WWW_Activate(dlgActivate.m_dwWindowID, dlgActivate.m_dwFlags);
	}	
}
void CNstestDoc::OnWwwCancelprogress() 
{
	// TODO: Add your command handler code here
	CDLGCancelProgress dlgCancel;
	
	if(dlgCancel.DoModal() == IDOK)	{
		m_pDDE->WWW_CancelProgress(dlgCancel.m_dwTransactionID);
	}
}

void CNstestDoc::OnWwwExit() 
{
	// TODO: Add your command handler code here
	m_pDDE->WWW_Exit();	
}

void CNstestDoc::OnWwwGetwindowinfo() 
{
	// TODO: Add your command handler code here
	CDLGGetWindowInfo dlgWinInfo;
	dlgWinInfo.m_dwWindowID = -1;
	
	if(dlgWinInfo.DoModal() == IDOK)	{
		m_pDDE->WWW_GetWindowInfo(dlgWinInfo.m_dwWindowID);
	}
}

void CNstestDoc::OnWwwOpenurl() 
{
	// TODO: Add your command handler code here
	CDLGOpenURL dlgURL;
	dlgURL.m_dwWindowID = -1;
	dlgURL.m_csProgressServer = m_pDDE->GetServiceName();
	
	if(dlgURL.DoModal() == IDOK)	{
		m_pDDE->WWW_OpenURL(dlgURL.m_csURL, dlgURL.m_csSaveAs, dlgURL.m_dwWindowID,
			dlgURL.m_dwFlags, dlgURL.m_csPostFormData, dlgURL.m_csPostMIMEType,
			dlgURL.m_csProgressServer);
	}	
}

void CNstestDoc::OnWwwParseanchor() 
{
	// TODO: Add your command handler code here
	CDLGParseAnchor dlgParse;
	
	if(dlgParse.DoModal() == IDOK)	{
		m_pDDE->WWW_ParseAnchor(dlgParse.m_csAbsoluteURL, dlgParse.m_csRelativeURL);
	}	
}

void CNstestDoc::OnWwwRegisterprotocol() 
{
	// TODO: Add your command handler code here
	CDLGRegisterProtocol dlgRegis;
	dlgRegis.m_csServer = m_pDDE->GetServiceName();
	
	if(dlgRegis.DoModal() == IDOK)	{
		m_pDDE->WWW_RegisterProtocol(dlgRegis.m_csServer, dlgRegis.m_csProtocol);
	}
}

void CNstestDoc::OnWwwRegisterurlecho() 
{
	// TODO: Add your command handler code here
	CDLGRegisterURLEcho dlgRegis;
	dlgRegis.m_csServer = m_pDDE->GetServiceName();
	
	if(dlgRegis.DoModal() == IDOK)	{
		m_pDDE->WWW_RegisterURLEcho(dlgRegis.m_csServer);
	}	
}

void CNstestDoc::OnWwwRegisterviewer() 
{
	// TODO: Add your command handler code here
	CDLGRegisterViewer dlgRegis;
	dlgRegis.m_csServer = m_pDDE->GetServiceName();
	
	if(dlgRegis.DoModal() == IDOK)	{
		m_pDDE->WWW_RegisterViewer(dlgRegis.m_csServer, dlgRegis.m_csMIMEType,
			dlgRegis.m_dwFlags);
	}	
}

void CNstestDoc::OnWwwRegisterwindowchange() 
{
	// TODO: Add your command handler code here
	CDLGRegisterWindowChange dlgRegis;
	dlgRegis.m_csServer = m_pDDE->GetServiceName();
	
	if(dlgRegis.DoModal() == IDOK)	{
		m_pDDE->WWW_RegisterWindowChange(dlgRegis.m_csServer, dlgRegis.m_dwWindowID);
	}
}

void CNstestDoc::OnWwwShowfile() 
{
	// TODO: Add your command handler code here
	CDLGShowFile dlgShow;
	dlgShow.m_dwWindowID = -1;
	
	if(dlgShow.DoModal() == IDOK)	{
		m_pDDE->WWW_ShowFile(dlgShow.m_csFileName, dlgShow.m_csMIMEType,
			dlgShow.m_dwWindowID, dlgShow.m_csURL);
	}
}

void CNstestDoc::OnWwwUnregisterprotocol() 
{
	// TODO: Add your command handler code here
	CUNRegisterProtocol dlgUN;
	dlgUN.m_csServer = m_pDDE->GetServiceName();
	
	if(dlgUN.DoModal() == IDOK)	{
		m_pDDE->WWW_UnRegisterProtocol(dlgUN.m_csServer, dlgUN.m_csProtocol);
	}
}

void CNstestDoc::OnWwwUnregisterurlecho() 
{
	// TODO: Add your command handler code here
	CUNRegisterURLEcho dlgUN;
	dlgUN.m_csServer = m_pDDE->GetServiceName();
	
	if(dlgUN.DoModal() == IDOK)	{
		m_pDDE->WWW_UnRegisterURLEcho(dlgUN.m_csServer);
	}
}

void CNstestDoc::OnWwwUnregisterviewer() 
{
	// TODO: Add your command handler code here
	CUNRegisterViewer dlgUN;
	dlgUN.m_csServer = m_pDDE->GetServiceName();
	
	if(dlgUN.DoModal() == IDOK)	{
		m_pDDE->WWW_UnRegisterViewer(dlgUN.m_csServer, dlgUN.m_csMIMEType);
	}	
}

void CNstestDoc::OnWwwUnregisterwindowchange() 
{
	// TODO: Add your command handler code here
	CUNRegisterWindowChange dlgUN;
	dlgUN.m_csServer = m_pDDE->GetServiceName();
	
	if(dlgUN.DoModal() == IDOK)	{
		m_pDDE->WWW_UnRegisterWindowChange(dlgUN.m_csServer,
			dlgUN.m_dwWindowID);
	}
}

void CNstestDoc::OnWwwVersion() 
{
	// TODO: Add your command handler code here
	m_pDDE->WWW_Version();
	
}

void CNstestDoc::OnWwwWindowchange() 
{
	// TODO: Add your command handler code here
	CDLGWindowChange dlgWin;
	
	if(dlgWin.DoModal() == IDOK)	{
		m_pDDE->WWW_WindowChange(dlgWin.m_dwWindowID, dlgWin.m_dwFlags,
			dlgWin.m_dwX, dlgWin.m_dwY, dlgWin.m_cwCX, dlgWin.m_cwCY);
	}
}

void CNstestDoc::OnWwwListwindows() 
{
	// TODO: Add your command handler code here	
	m_pDDE->WWW_ListWindows();	
}

void CNstestDoc::OnWwwQueryurlfile() 
{
	// TODO: Add your command handler code here
	CDQueryURLFile dlgFile;
	
	if(dlgFile.DoModal() == IDOK)	{
		m_pDDE->WWW_QueryURLFile(dlgFile.m_csFileName);
	}
}

void CNstestDoc::OnOleNetwork1Bytesready() 
{
	// TODO: Add your command handler code here
	short sReady = m_pOLENetwork1->BytesReady();
	
	char aBuf[512];
	sprintf(aBuf, "OLE %d CNetscapeNetwork1::BytesReady();", sReady);
	Display(aBuf);
}

void CNstestDoc::OnOleNetwork1Close() 
{
	// TODO: Add your command handler code here	
	m_pOLENetwork1->Close();
	
	char aBuf[512];
	sprintf(aBuf, "OLE void CNetscapeNetwork1::Close();");
	Display(aBuf);
}

void CNstestDoc::OnOleNetwork1Getcontentencoding() 
{
	// TODO: Add your command handler code here	
	CString csEncoding = m_pOLENetwork1->GetContentEncoding();
	
	char aBuf[512];
	sprintf(aBuf, "OLE %s CNetscapeNetwork1::GetContentEncoding();",
		(const char *)csEncoding);
	Display(aBuf);	
}

void CNstestDoc::OnOleNetwork1Getcontentlength() 
{
	// TODO: Add your command handler code here
	long lLength = m_pOLENetwork1->GetContentLength();
	
	char aBuf[512];
	sprintf(aBuf, "OLE %ld CNetscapeNetwork1::GetContentLength();", lLength);
	Display(aBuf);
}

void CNstestDoc::OnOleNetwork1Getcontenttype() 
{
	// TODO: Add your command handler code here
	CString csType = m_pOLENetwork1->GetContentType();
	
	char aBuf[512];
	sprintf(aBuf, "OLE %s CNetscapeNetwork1::GetContentType();",
		(const char *)csType);
	Display(aBuf);	
}

void CNstestDoc::OnOleNetwork1Geterrormessage() 
{
	// TODO: Add your command handler code here
	CString csError = m_pOLENetwork1->GetErrorMessage();
	
	char aBuf[512];
	sprintf(aBuf, "OLE %s CNetscapeNetwork1::GetErrorMessage();",
		(const char *)csError);
	Display(aBuf);	
}

void CNstestDoc::OnOleNetwork1Getexpires() 
{
	// TODO: Add your command handler code here
	CString csExpires = m_pOLENetwork1->GetExpires();
	
	char aBuf[512];
	sprintf(aBuf, "OLE %s CNetscapeNetwork1::GetExpires();",
		(const char *)csExpires);
	Display(aBuf);
}

void CNstestDoc::OnOleNetwork1Getflagfancyftp() 
{
	// TODO: Add your command handler code here
	BOOL bFancy = m_pOLENetwork1->GetFlagFancyFTP();
	
	char aBuf[512];
	sprintf(aBuf, "OLE %s CNetscapeNetwork1::GetFlagFancyFTP();",
		(const char *)ExplainBool(bFancy));
	Display(aBuf);
}

void CNstestDoc::OnOleNetwork1Getflagfancynews() 
{
	// TODO: Add your command handler code here
	BOOL bFancy = m_pOLENetwork1->GetFlagFancyNews();
	
	char aBuf[512];
	sprintf(aBuf, "OLE %s CNetscapeNetwork1::GetFlagFancyNews();",
		(const char *)ExplainBool(bFancy));
	Display(aBuf);
}

void CNstestDoc::OnOleNetwork1Getflagshowallnews() 
{
	// TODO: Add your command handler code here
	BOOL bShowAll = m_pOLENetwork1->GetFlagShowAllNews();
	
	char aBuf[512];
	sprintf(aBuf, "OLE %s CNetscapeNetwork1::GetFlagShowAllNews();",
		(const char *)ExplainBool(bShowAll));
	Display(aBuf);
}

void CNstestDoc::OnOleNetwork1Getlastmodified() 
{
	// TODO: Add your command handler code here
	CString csModified = m_pOLENetwork1->GetLastModified();
	
	char aBuf[512];
	sprintf(aBuf, "OLE %s CNetscapeNetwork1::GetLastModified();",
		(const char *)csModified);
	Display(aBuf);
}

void CNstestDoc::OnOleNetwork1Getpassword() 
{
	// TODO: Add your command handler code here
	CString csPassword = m_pOLENetwork1->GetPassword();
	
	char aBuf[512];
	sprintf(aBuf, "OLE %s CNetscapeNetwork1::GetPassword();",
		(const char *)csPassword);
	Display(aBuf);
}

void CNstestDoc::OnOleNetwork1Getserverstatus() 
{
	// TODO: Add your command handler code here
	short sStatus = m_pOLENetwork1->GetServerStatus();
	
	char aBuf[512];
	sprintf(aBuf, "OLE %d CNetscapeNetwork1::GetServerStatus();",
		sStatus);
	Display(aBuf);
}

void CNstestDoc::OnOleNetwork1Getstatus() 
{
	// TODO: Add your command handler code here
	long lStatus = m_pOLENetwork1->GetStatus();
	
	char aBuf[512];
	sprintf(aBuf, "OLE %ld CNetscapeNetwork1::GetStatus();", lStatus);
	Display(aBuf);	
}

void CNstestDoc::OnOleNetwork1Getusername() 
{
	// TODO: Add your command handler code here
	CString csUsername = m_pOLENetwork1->GetUsername();
	
	char aBuf[512];
	sprintf(aBuf, "OLE %s CNetscapeNetwork1::GetUsername();",
		(const char *)csUsername);
	Display(aBuf);
}

void CNstestDoc::OnOleNetwork1Isfinished() 
{
	// TODO: Add your command handler code here
	BOOL bFinished = m_pOLENetwork1->IsFinished();
	
	char aBuf[512];
	sprintf(aBuf, "OLE %s CNetscapeNetwork1::IsFinished();",
		(const char *)ExplainBool(bFinished));
	Display(aBuf);
}

void CNstestDoc::OnOleNetwork1Open() 
{
	// TODO: Add your command handler code here
	CODNetOpen dlgOle;
	
	dlgOle.m_sMethod = 0x0;	
	
	if(dlgOle.DoModal() == IDOK)	{	
		BOOL bResult = m_pOLENetwork1->Open(dlgOle.m_csURL, dlgOle.m_sMethod,
			dlgOle.m_csPostData, dlgOle.m_lPostDataSize,
			dlgOle.m_csPostHeaders);
	
		char aBuf[2048];
		sprintf(aBuf, "OLE %s CNetscapeNetwork1::Open(%s,%d,%s,%ld,%s);",
			(const char *)ExplainBool(bResult),
			(const char *)dlgOle.m_csURL,
			dlgOle.m_sMethod,
			(const char *)dlgOle.m_csPostData,
			dlgOle.m_lPostDataSize,
			(const char *)dlgOle.m_csPostHeaders);
		Display(aBuf);
	}	
}

void CNstestDoc::OnOleNetwork1Read() 
{
	// TODO: Add your command handler code here
	CODNetRead dlgOle;
	
	if(dlgOle.DoModal() == IDOK)	{
		BSTR pBuffer = SysAllocStringLen(NULL, dlgOle.m_sAmount);
		short sResult = m_pOLENetwork1->Read(&pBuffer, dlgOle.m_sAmount);
		
		//	Set the final byte to end the string, then copy it.
		if(sResult != -1)	{
			*(pBuffer + sResult) = '\0';
		}
		else	{
			*pBuffer = '\0';
		}		
		CString csRead = pBuffer;
		SysFreeString(pBuffer);
	
		char *pBuf = new char[128 + csRead.GetLength()];
		sprintf(pBuf, "OLE %d CNetscapeNetwork1::Read(%s,%d);", sResult,
			(const char *)csRead, dlgOle.m_sAmount);
		Display(pBuf);
		delete[] pBuf;
	}	
}

void CNstestDoc::OnOleNetwork1Resolve() 
{
	// TODO: Add your command handler code here
	CODNetResolve dlgOle;
	
	if(dlgOle.DoModal() == IDOK)	{
		CString csResult = m_pOLENetwork1->Resolve(dlgOle.m_csBase,
			dlgOle.m_csRelative);
	
		char aBuf[2048];
		sprintf(aBuf, "OLE %s CNetscapeNetwork1::Resolve(%s,%s);",
			(const char *)csResult,
			(const char *)dlgOle.m_csBase,
			(const char *)dlgOle.m_csRelative);
		Display(aBuf);
	}	
}

void CNstestDoc::OnOleNetwork1Setflagfancyftp() 
{
	// TODO: Add your command handler code here
	CODNetSetFlagFancyFTP dlgOle;
	
	if(dlgOle.DoModal() == IDOK)	{
		m_pOLENetwork1->SetFlagFancyFTP(dlgOle.m_bFancy);
	
		char aBuf[512];
		sprintf(aBuf, "OLE void CNetscapeNetwork1::SetFlagFancyFTP(%s);",
			(const char *)ExplainBool(dlgOle.m_bFancy));
		Display(aBuf);
	}	
}

void CNstestDoc::OnOleNetwork1Setflagfancynews() 
{
	// TODO: Add your command handler code here
	CODNetSetFlagFancyNews dlgOle;
	
	if(dlgOle.DoModal() == IDOK)	{
		m_pOLENetwork1->SetFlagFancyNews(dlgOle.m_bFancy);	
	
		char aBuf[512];
		sprintf(aBuf, "OLE void CNetscapeNetwork1::SetFlagFancyNews(%s);",
			(const char *)ExplainBool(dlgOle.m_bFancy));
		Display(aBuf);
	}	
}

void CNstestDoc::OnOleNetwork1Setflagshowallnews() 
{
	// TODO: Add your command handler code here
	CODNetSetFlagShowAllNews dlgOle;
	
	if(dlgOle.DoModal() == IDOK)	{
		m_pOLENetwork1->SetFlagShowAllNews(dlgOle.m_bShowAll);
	
		char aBuf[512];
		sprintf(aBuf, "OLE void CNetscapeNetwork1::SetFlagShowAllNews(%s);",
			(const char *)ExplainBool(dlgOle.m_bShowAll));
		Display(aBuf);
	}	
}

void CNstestDoc::OnOleNetwork1Setpassword() 
{
	// TODO: Add your command handler code here
	CODNetSetPassword dlgOle;
	
	if(dlgOle.DoModal() == IDOK)	{
		m_pOLENetwork1->SetPassword(dlgOle.m_csPassword);
	
		char aBuf[512];
		sprintf(aBuf, "OLE void CNetscapeNetwork1::SetPassword(%s);",
			(const char *)dlgOle.m_csPassword);
		Display(aBuf);
	}	
}

void CNstestDoc::OnOleNetwork1Setusername() 
{
	// TODO: Add your command handler code here
	CODNetSetUsername dlgOle;
	
	if(dlgOle.DoModal() == IDOK)	{
		m_pOLENetwork1->SetUsername(dlgOle.m_csUsername);
	
		char aBuf[512];
		sprintf(aBuf, "OLE void CNetscapeNetwork1::SetUsername(%s);",
			(const char *)dlgOle.m_csUsername);
		Display(aBuf);
	}	
}

void CNstestDoc::OnOleRegistry1Registerprotocol() 
{
	// TODO: Add your command handler code here
	CODRegProtocol dlgRegPro;
	dlgRegPro.m_csServer = "Nstest.Protocol.1";
	
	if(dlgRegPro.DoModal() == IDOK)	{
		//	If successful, entries can be found in Netscape.ini (take them
		//		out there if need be)
		BOOL bResult = m_pOLERegistry1->RegisterProtocol(
			dlgRegPro.m_csProtocol, dlgRegPro.m_csServer);
		
		char aBuf[512];
		sprintf(aBuf, "OLE %s CNetscapeRegistry1::RegisterProtocol(%s,%s);",
			(const char *)ExplainBool(bResult),
			(const char *)dlgRegPro.m_csProtocol,
			(const char *)dlgRegPro.m_csServer);
		Display(aBuf);
	}
}

void CNstestDoc::OnOleRegistry1Registerviewer() 
{
	// TODO: Add your command handler code here
	CODRegViewer dlgRegViewer;
	dlgRegViewer.m_csServer = "Nstest.Viewer.1";
	
	if(dlgRegViewer.DoModal() == IDOK)	{
		//	If successful, entries can be found in Netscape.ini (take them
		//		out there if need be)
		BOOL bResult = m_pOLERegistry1->RegisterViewer(
			dlgRegViewer.m_csMimeType, dlgRegViewer.m_csServer);
			
		char aBuf[512];
		sprintf(aBuf, "OLE %s CNetscapeRegistry1::RegisterViewer(%s,%s);",
			(const char *)ExplainBool(bResult),
			(const char *)dlgRegViewer.m_csMimeType,
			(const char *)dlgRegViewer.m_csServer);
		Display(aBuf);
	}
}
